import React from 'react'
import PropTypes from 'prop-types'
import {
  Form, Row, Col, Card, Select,
  Input,
  Button,
  Modal
} from 'antd'


const ColProps = {
  xs: 24,
  sm: 12,
  style: {
    margin: 16,
  },
}

class Add extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      Data: {
        coord: '',
        behavior: ''
      }
    },
    this.Data = {
      /**
      * title    提示标题
      * content  提示内容
      * 
      */
      title: '填写信息有误',
      content: '坐标有误请重新填写'
    }
  }

  warning = () => {
    Modal.warning({
      title: this.Data.text,
      content: this.Data.content,
    });
  }

  addData = () => {
    //   //获取输入值
    const newStateLng = parseFloat(this.refs.myLng.refs.input.value)
    const newStateLat = parseFloat(this.refs.myLat.refs.input.value)
    this.refs.myLng.refs.input.value = ""
    this.refs.myLat.refs.input.value = ""
    if (isNaN(newStateLng) || isNaN(newStateLat)) {
      return this.warning()
    }
    let newData = {
      coord: {
        lng: newStateLng,
        lat: newStateLat
      },
      behavior: 'add'
    }

    this.props.callbackAdd(newData);

  }

  render() {
    return (
      <Row gutter={24}>
        <Col {...ColProps} xl={{ span: 10 }} md={{ span: 10 }} sm={{ span: 10 }}>
          <div style={{ display: 'flex', justifyContent: 'space-between' }}>
            <Input type='number' placeholder="经度" size="large" ref="myLng" />
            <Input type='number' placeholder="纬度" size="large" ref="myLat" />
            <Input  placeholder="Search Name" size="large" />
            <Button type="primary" size="large" className="margin-right" onClick={this.addData} >添加</Button>
          </div>
        </Col>
      </Row>
    )
  }
}

export default Add