import React from 'react'
import PropTypes from 'prop-types'
import Compile from './BaiduCompile'
import {
  Form, Row, Col, Card, Select,
  Input,
  Button,
  Modal,
  Radio,
} from 'antd'

const InputGroup = Input.Group;
const ColProps = {
  xs: 24,
  sm: 12,
  style: {
    margin: 16,
  },
}
const confirm = Modal.confirm;
class Delete extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      Data: {
        coord: '',
        behavior: ''
      }
    }
  }
  dltAlert = () => {
    const _this = this
    let Delete = this.props.Delete
    const newStateLng = this.refs.dlLng.refs.input.defaultValue
    const newStateLat = this.refs.dlLat.refs.input.defaultValue
    if (isNaN(newStateLng) || isNaN(newStateLat)) {
      return Modal.info({
        title: '请在地图上确认需要删除的点!',
        onOk() { },
      })
    }
    //确认框
    confirm({
      title: `请在地图上确认删除的点?`,
      content: `经度:${Delete.coord.lng},纬度:${Delete.coord.lat}`,
      onOk() {
        let newData = {
          coord: Delete.coord,
          behavior: 'Delete'
        }
        _this.setState({
          Data: newData,
        })
        _this.props.callbackConfDelete(newData);
      },

      onCancel() {
        console.log('取消');

      },
    });
  }

  render() {
    let isDelete = this.props.Delete
    let Delete = this.props.Delete.coord
    let gg=''
    let bb=''
    if(isDelete.behavior=='ClickMap'){
      gg=Delete.lng
      bb=Delete.lat
    }else{
      gg=''
      bb=''
    }
    return (
      <Row gutter={24} >
        <Col {...ColProps} xl={{ span: 9 }} md={{ span: 10 }} sm={{ span: 10 }}>
          <div style={{ display: 'flex', justifyContent: 'space-between' }}>
            <Input className='alng' placeholder="经度" size="large" ref="dlLng" value={ gg } />
            <Input type='number' placeholder="纬度" size="large" ref="dlLat" value={bb} />
            <Input type='number' placeholder="Search Name" size="large" />
            <Button type="primary" size="large" className="margin-right" onClick={this.dltAlert}
            >删除</Button>
            <Compile 
              Delete={isDelete}
              // /这是一个过渡   从这里将回调传入index
              callbackCompile={this.props.callbackCompile}
            />
          </div>
        </Col>
      </Row>
    )
  }
}

export default Delete



