import {default as React,Component} from "react";
import { Row, Col, Card, Select, Input, Button,} from 'antd'
import BMap from 'BMap'
import BaiduArea from './BaiduArea'
import Distance from './BaiduDistance'
// const BMap = window.BMap
let map
const posts = {
  data: [{
      lng: 121.309056,
      lat: 31.22383
    },
    {
      lng: 121.309918,
      lat: 31.207647
    },
    {
      lng: 121.322998,
      lat: 31.185036
    },
    {
      lng: 121.331046,
      lat: 31.171689
    },
    {
      lng: 121.331621,
      lat: 31.170082
    },
    {
      lng: 121.353324,
      lat: 31.177868
    },
    {
      lng: 121.363673,
      lat: 31.187755
    },
    {
      lng: 121.35548,
      lat: 31.229018
    },
    {
      lng: 121.335646,
      lat: 31.229141
    },
    {
      lng: 121.317967,
      lat: 31.224201
    },
  ]
}
const opts = {
  width: 250, // 信息窗口宽度
  height: 80, // 信息窗口高度
  title: "信息窗口", // 信息窗口标题
  enableMessage: true, //设置允许信息窗发送短息
  size: window.BMP_POINT_SIZE_SMALL,
  shape: window.BMAP_POINT_SHAPE_CIRCLE,
  color: '#e70f0f'
};
var polygonPoints = [];

class InitMap extends Component {
  constructor(props) {
    super(props)
    this.state = {
      Data: {
        coord: '',
        behavior: ''
      }
    }
  }
  componentDidMount() {
    this.initMap()
  }
  initMap = (State) => {
    const _this = this
    map = new BMap.Map("allmap"); // 创建Map实例
    map.centerAndZoom(new BMap.Point(116.404, 39.915), 11); // 初始化地图,设置中心点坐标和地图级别
    map.addControl(new BMap.MapTypeControl()); //添加地图类型控件
    map.setCurrentCity("北京"); // 设置地图显示的城市 此项是必须设置的
    map.enableScrollWheelZoom(true); //开启鼠标滚轮缩放 
    const Coord = []
    if(State){
      let behavior= State.behavior
      let coord=State.coord
      let data1=posts.data
      if(behavior=="add"){
        data1.push(coord)
      }
      if(behavior=="Delete"){
        for (let i of data1){
          if((i.lng==coord.lng)&&(i.lat==coord.lat)){
            data1.splice(data1.indexOf(i), 1);
          }
        }
        // data.splice(data.indexOf(coord), 1);
      }
      if(behavior=="Compile"){
          let data2={
            lng:coord.xlng,
            lat:coord.xlat
          }
          let ott=false
          for (let i of data1){
            if((i.lng==coord.lng)&&(i.lat==coord.lat)){
              data1.splice(data1.indexOf(i), 1,data2)
              ott=!ott
            }
          }
        if(!ott){
          alert('该点不存在')
        }
      }
    }

    for (let i of posts.data) {
      Coord.push(new BMap.Point(i.lng, i.lat))
    }
    const polygon = new BMap.Polygon(Coord, {
      strokeColor: "red",
      strokeWeight: 2,
      strokeOpacity: 0.8
    })
    this.setState({
      Post: polygon
    })
    let newData = {}
    // for (var i = 0; i < Coord.length; i++) {
    //   const map_coord = Coord[i]
    for (var i = 0; i < Coord.length; i++) {
      const map_coord = Coord[i]
      const sContent = "<div class='city_BG'>" +
        "<table style='height: 100%;width: 100%;line-height:1.8em;font-size:12px;'>" +
        "<tr>" + "<td>经度" + map_coord.lng + "</td>" + "</tr>" +
        "<tr>" + "<td>纬度:" + map_coord.lat + "</td>" + "</tr>" +
        "</table>" +
        "</div>";
      //第一个坐标点定位
      if (0 == i) {
        map.panTo(map_coord);
        map.setZoom(10);
      }
      const myIcon = new BMap.Symbol(window.BMap_Symbol_SHAPE_CIRCLE, {
        scale: 5,
        strokeWeight: 1,
        rotation: 180,
        fillColor: '#e70f0f',
        fillOpacity: 0.8
      });
      // 将标注添加到地图中
      const marker = new BMap.Marker(map_coord, {
        icon: myIcon
      });
      map.addOverlay(marker);
      addClickHandler(sContent, marker);

      function addClickHandler(sContent, marker) {
        marker.addEventListener("click", (e) => { 
          openInfo(sContent, e)
          //保存 新的数据
          _this.setState({
            Data: newData
          })
          _this.props.callbackDelete(newData);
        })
      }

      //添加多边形
      // const polygon = new BMap.Polygon(Coord,{strokeColor:"red", strokeWeight:2, strokeOpacity:0.8})
      map.addOverlay(polygon);
      polygon.addEventListener("mouseover", function () {
        polygon.setStrokeColor("red");
        map.addOverlay(polygon); //显示面积
      });
      // 创建信息窗口对象 
      const openInfo = (sContent, e) => {
        const point = new BMap.Point(map_coord.lng, map_coord.lat);
        const DeleteData = {
          lng: point.lng,
          lat: point.lat
        }
        const infoWindow = new BMap.InfoWindow(sContent, opts);
        map.openInfoWindow(infoWindow, point); //开启信息窗口
        newData = {
          coord: DeleteData,
          behavior: 'ClickMap'
        }
      }
      //坐标连线
      const polyline = new BMap.Polyline(Coord, {
        strokeColor: "blue",
        strokeWeight: 2,
        strokeOpacity: 0.5
      });
      map.addOverlay(polyline);
    }
  }
  //Add.js的添加坐标点的数据
  componentWillReceiveProps(nextProps) {
    const State=nextProps.State
    // 判断功能
    if(State.behavior=="ClickMap"){
      return
    }else{
      // 重新渲染
      this.initMap(State)
    }
  }
  dist = () => {
    const myDis = new window.BMapLib.DistanceTool(map);
    myDis.open()
  }
  measure = () => {
    const styleOptions = {
      strokeWeight: 3,       //边线的宽度，以像素为单位。
      strokeOpacity: 0.8,	   //边线透明度，取值范围0 - 1。
      fillOpacity: 0.6,      //填充的透明度，取值范围0 - 1。
      strokeStyle: 'solid' //边线的样式，solid或dashed。
    }
    var drawingManager = new window.BMapLib.DrawingManager(map,{
      isOpen: true, //是否开启绘制模式
      enableCalculate:true,//开启测面模式
      // drawingType: BMAP_DRAWING_POLYGON //多边形的样式
      
    });
    drawingManager.setDrawingMode(window.BMAP_DRAWING_POLYGON)
    drawingManager.addEventListener("overlaycomplete", onDrawPolygon);
    // drawingManager.enableCalculate();
    function onDrawPolygon(overlay, point) {
      var htmls = [];
      htmls.push("<span>总长：<span>" + point.calculate/667 + "</span>" + "米" + "</span><br />");
      const lnglat = polygonPoints[polygonPoints.length - 1];
      // var marker = new BMap.Marker(point)
      // map.addOverlay(marker);
      const infoWindow = new BMap.InfoWindow(lnglat, opts);
      infoWindow.setContent(htmls.join(''));
      map.openInfoWindow(infoWindow,point);
    }
  }

  render() {
    let Post=this.state.Post
    return (
      <Row gutter={24} >
      <BaiduArea Posts={Post}/>
      <Col lg={24} md={24}>
        <Card bordered={false} >
          <Distance dist={this.dist} Posts={Post} measure={this.measure}/>
          <div
            id='allmap'
            style={{
              height: '80vh'
            }} />
        </Card>
      </Col>
    </Row>
    );
  }
}
export default InitMap;