import * as React from "react";
import * as ReactDOM from "react-dom";
import  ol from 'openlayers';
import { Button,Select } from 'antd';
import { Link } from 'react-router';
const Option = Select.Option;
let tooltip ={
  position: 'relative',
  background: 'rgba(0, 0, 0, 0.5)',
  borderRadius: '4px',
  color: 'white',
  padding: '4px 8px',
  opacity: 0.7,
  whiteSpace: 'nowrap',
}
let tooltipMeasure= {
  opacity: "1",
  fontWweight: 'bold'
}
let tooltipStatic= {
  backgroundColor:'#501212',
  color: 'black',
  border: '1px solid white',
}
var Satellite = new ol.layer.Tile({
  source: new ol.source.XYZ({  
      url: 'http://khm{0-3}.googleapis.com/kh?v=742&hl=pl&&x={x}&y={y}&z={z}',
  })
});

var formatLength = function(line) { 
  var length = ol.Sphere.getLength(line);
  var output;
  if (length > 100) {
    output = (Math.round(length / 1000 * 100) / 100) +
        ' ' + 'km';
  } else {
    output = (Math.round(length * 100) / 100) +
        ' ' + 'm';
  }
  return output;
};

var source = new ol.source.Vector();

var vector = new ol.layer.Vector({
  source: source,
  style: new ol.style.Style({
    fill: new ol.style.Fill({
      color: 'rgba(255, 255, 255, 0.2)'
    }),
    stroke: new ol.style.Stroke({
      color: '#ffcc33',
      width: 2
    }),
    image: new ol.style.Circle({
      radius: 7,
      fill: new ol.style.Fill({
        color: '#ffcc33'
      })
    })
  })
});

let map
let layers=new ol.layer.Tile({source: new ol.source.TileImage({ url: 'http://www.google.cn/maps/vt/pb=!1m4!1m3!1i{z}!2i{x}!3i{y}!2m3!1e0!2sm!3i380072576!3m8!2szh-CN!3scn!5e1105!12m4!1e68!2m2!1sset!2sRoadmap!4e0!5m1!1e0'})})

class Code3 extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      text:''
    }
  }
  componentDidMount(){
          map = new ol.Map({
          layers: [Satellite],
          target: 'map1',
          view: new ol.View({
            center: [-6655.5402445057125, 6709968.258934638],
            zoom: 13
          })
        });
        // map.addLayer(source);
        map.addLayer(vector);
  }

  handleChange=(value)=>{     
    let _this=this
    console.log(value)
    var draw
    var sketch;

    var helpTooltipElement;

    var helpTooltip;

    var measureTooltipElement;
    var measureTooltip;

    var continuePolygonMsg = 'Click to continue drawing the polygon';

    var continueLineMsg = 'Click to continue drawing the line';
    console.log(this.state.draw,'00356')
    // map.removeInteraction(this.state.draw);
    map.removeInteraction(this.state.draw);
    var pointerMoveHandler = function(evt) {
      console.log(evt.dragging,sketch,'evt')
    };
    map.on('pointermove', pointerMoveHandler);
    var formatArea = function(polygon) {
      var area = ol.Sphere.getArea(polygon);
      var output;
      if (area > 10000) {
        output = (Math.round(area / 1000000 * 100) / 100) +
          ' ' + 'km<sup>2</sup>';
      } else {
        output = (Math.round(area * 100) / 100) +
          ' ' + 'm<sup>2</sup>';
      }
      return output;
    };
    function addInteraction() {
      var type = (value == 'area' ? 'Polygon' : 'LineString');
      draw = new ol.interaction.Draw({
        source: vector.getSource(),
        type: type,
        style: new ol.style.Style({
          fill: new ol.style.Fill({
            color: 'rgba(255, 255, 255, 0.2)'
          }),
          stroke: new ol.style.Stroke({
            color: 'yellow',
            // lineDash: [10, 10],
            width: 2
          }),
          image: new ol.style.Circle({
            radius: 5,
            stroke: new ol.style.Stroke({
              color: 'green'
            }),
            fill: new ol.style.Fill({
              color: 'white'
            })
          })
        })
      });
      map.addInteraction(draw);

      createMeasureTooltip();

      var listener;
      draw.on('drawstart',
        function(evt) {
          // set sketch
          sketch = evt.feature;

          /** @type {ol.Coordinate|undefined} */
          var tooltipCoord = evt.coordinate;

          listener = sketch.getGeometry().on('change', function(evt) {
            var geom = evt.target;
            var output;
            if (geom instanceof ol.geom.Polygon) {
              output = formatArea(geom);
              tooltipCoord = geom.getInteriorPoint().getCoordinates();
            } else if (geom instanceof ol.geom.LineString) {
              output = formatLength(geom);
              tooltipCoord = geom.getLastCoordinate();
            }
            measureTooltipElement.innerHTML = output;
            // console.log()
            console.log(measureTooltipElement,measureTooltip,88)
            measureTooltip.setPosition(tooltipCoord);
          });
        }, this);

      draw.on('drawend',
        function() {
          for (let i in tooltip) {  
                measureTooltipElement.style[i] =tooltip[i]
            } 
          measureTooltip.setOffset([0, -7]);
          // unset sketch
          sketch = null;
          console.log(measureTooltipElement,measureTooltip,444)
          // unset tooltip so that a new one can be created
          measureTooltipElement = null;
          createMeasureTooltip();
          ol.Observable.unByKey(listener);
        }, this)
      _this.setState({
        draw:draw
      });
    }


      /**
       * Creates a new measure tooltip
       */
    function createMeasureTooltip() {
      if (measureTooltipElement) {
        measureTooltipElement.parentNode.removeChild(measureTooltipElement);
      }
      measureTooltipElement = document.createElement('div');
      //可以修改字体颜色
      for (let i in tooltip) {  
        measureTooltipElement.style[i] =tooltip[i]
      }  
      measureTooltip = new ol.Overlay({
        element: measureTooltipElement,
        offset: [0, -15],
        positioning: 'bottom-center'
      });
      map.addOverlay(measureTooltip);
    }

    addInteraction();
  }
  render(){
    return (
        <div>
            <div id="map1" style={{height:'500px'}}></div>
            <div>选择:<Select
              showSearch
              style={{ width: 200 }}
              placeholder="请选择样式"
              optionFilterProp="children"
              onChange={this.handleChange}
              // onFocus={handleFocus}
              // onBlur={handleBlur}
              filterOption={(input, option) => option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0}
            >
              <Option key='length' value="LineString">距离</Option>
              <Option key ='area'value="area">面积</Option>
            </Select>
            </div>
        </div>
    );
  }
}
export default Code3;