import * as React from "react";
import * as ReactDOM from "react-dom";
import * as ol from 'openlayers';
import { Button,Select } from 'antd';
import { Link } from 'react-router';
import {
  interaction, layer, custom, control, //name spaces
  Interactions, Overlays, Controls,     //group
  Map, Layers, Overlay, Util    //objects
} from "react-openlayers";
// import { Button } from "../../../node_modules/_antd@2.12.8@antd/lib/radio";
const Option = Select.Option;
// window.app = {};
let map
// var app = window.app;
//天地图地名图层
var tianditu = new ol.layer.Tile({
  source: new ol.source.XYZ({
    url:'http://t{0-7}.tianditu.com/DataServer?T=cia_w&x={x}&y={y}&l={z}',
  })
})
//谷歌卫星地图图层
var Satellite = new ol.layer.Tile({
  source: new ol.source.XYZ({  
      url: 'http://khm{0-3}.googleapis.com/kh?v=742&hl=pl&&x={x}&y={y}&z={z}',
  })
});
// var untiled = new ol.layer.Tile({
//   source: new ol.source.TileJSON({
//     url: 'https://api.tiles.mapbox.com/v3/mapbox.20110804-hoa-foodinsecurity-3month.json?secure',
//     crossOrigin: 'anonymous'
//   })
// })
//覆盖物图层
var source =new ol.layer.Vector({
  source: new ol.source.Vector(),
  style: new ol.style.Style({
      stroke: new ol.style.Stroke({
          color: 'yellow',
          size: 1
      })
  })
})
// var source = new ol.source.Vector({wrapX: false});
class DMap extends React.Component {
  constructor(props) {
    super(props);
    this.state={
      Satellite:true,
    // gsat:2
    }
  }
  componentDidMount(){
    map = new ol.Map({
      layers: [
        new ol.layer.Tile({
          source: new ol.source.OSM()
        }), new ol.layer.Group({
          layers: [
            // vector
            Satellite,
            tianditu

          ]
        })
      ],
      target: 'map',
      view: new ol.View({
        center: ol.proj.fromLonLat([37.40570, 8.81566]),
        zoom: 4
      })
    })
    //添加覆盖图层 
    map.addLayer(source);
    ;
  }
//选择事件
  handleChange=(value)=> {
    console.log(value)
    let _this=this
    // map.addLayer(source);
    map.removeInteraction(this.state.draw);
    var draw
    function addInteraction(value){
      if (value !== 'None') {
        console.log(value,999)
        draw = new ol.interaction.Draw({
          type:value,
          source: source.getSource(),
        });
        map.addInteraction(draw);

      }
      _this.setState({
        draw:draw
      })
    }

    addInteraction(value)

  }
  //点击事件  设置图层层级
  btnClick=()=>{
    if(this.state.Satellite){
      Satellite.setZIndex(3);
      tianditu.setZIndex(1);
      this.setState({Satellite:false})
    }else{
      tianditu.setZIndex(3);
      Satellite.setZIndex(1);
      this.setState({Satellite:true})
    }
  }
  render(){
    return (
      <div>
      <div id='map'style={{position: 'relative'}} >
      <Button ghost
        style={{position: 'absolute',  
        top: '6px' , 
        left:' 40px' ,zIndex:'100' ,
        background:' rgba(0,155,100,0.5)',
        color:'white',userSelect:'none'}}
        onClick={this.btnClick}>{!this.state.Satellite?'显示':'隐藏'}地名</Button>
      </div>
      <div>选择:<Select
        showSearch
        style={{ width: 200 }}
        placeholder="请选择样式"
        optionFilterProp="children"
        onChange={this.handleChange}
        // onFocus={handleFocus}
        // onBlur={handleBlur}
        filterOption={(input, option) => option.props.children.toLowerCase().indexOf(input.toLowerCase()) >= 0}
      >
        <Option key='Point' value="Point">点</Option>
        <Option key ='LineString'value="LineString">线</Option>
        <Option key='Polygon'value="Polygon">面</Option>
        <Option key='Circle'value="Circle">圆</Option>
        <Option key='None'value="None">无</Option>
      </Select>
      </div>
        <Button><Link to={'/app/map/OpenlayerTest'}>测 试</Link></Button>
      </div>
    );
  }
}
export default DMap;


