import React from 'react';
import { Form, Icon, Input, Button, Checkbox, message } from 'antd';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import { fetchData, receiveData } from '@/action';


const FormItem = Form.Item;

class Change extends React.Component {
    state = {
        confirmDirty: false,
    };
    componentWillMount() {
        const { receiveData } = this.props;
        receiveData(null, 'auth');
    }
    componentWillReceiveProps(nextProps) {
        const { auth: nextAuth = {} } = nextProps;
        const { router } = this.props;
        console.log(nextAuth)
        if (nextAuth.isFetching === true) {
            
        }else{
           
        }
    }
    handleConfirmBlur = (e) => {
        const value = e.target.value;
        this.setState({ confirmDirty: this.state.confirmDirty || !!value });
    };
    checkPassword = (rule, value, callback) => {
        const form = this.props.form;
        if (value && value !== form.getFieldValue('password')) {
            callback('Two passwords that you enter is inconsistent!');
        } else {
            callback();
        }
    };
    checkConfirm = (rule, value, callback) => {
        const form = this.props.form;
        if (value && this.state.confirmDirty) {
            form.validateFields(['confirm'], { force: true });
        }
        callback();
    };
    handleSubmit = (e) => {
        const { router } = this.props;
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (!err) {
                let data = {
                    oldPassword : this.state.oldPassword,
                    password: this.state.password,
                    confirm : this.state.confirm,
                }
                fetch({
                    method: 'GET',
                })
                .then(function(data) {
                    router.push('/login');
           
                })
                .catch(function(error) {        
                    console.log('request failed', error)
                })
                console.log('Received values of form: ', values);
            }
        });
    };

    render() {
        const { getFieldDecorator } = this.props.form;
        return (
            <div className="login">
                <div className="login-form" >
                    <div className="login-logo">
                        <span>修改密码</span>
                    </div>
                    <Form onSubmit={this.handleSubmit} style={{maxWidth: '300px'}}>
                        <FormItem>
                            {getFieldDecorator('oldPassword', {
                                rules: [{ required: true,
                                    pattern : /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8}/,
                                    message: '密码有误'
                                }],
                                
                            })(
                                <Input className="oldPassword" prefix={<Icon type="lock" style={{ fontSize: 13}} />} type="password" placeholder="原密码"/>
                            )}
                        </FormItem>
                        <FormItem>
                            {getFieldDecorator('password', {
                               rules: [{
                                required: true,
                                pattern : /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8}/,
                                message: '请输入密码!',
                            }, {
                                validator: this.checkConfirm,
                            }],
                                
                            })(
                                <Input prefix={<Icon type="lock" style={{ fontSize: 13 }} />} type="password" placeholder="新密码" />
                            )}
                        </FormItem>
                        <FormItem>
                            {getFieldDecorator('confirm', {
                                 rules: [{
                                required: true,
                                pattern : /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8}/,
                                message: '请确认你的密码!',
                            }, {
                                validator: this.checkPassword,
                            }], 
                            })(
                                <Input type="password" prefix={<Icon type="lock" style={{ fontSize: 13 }} />} placeholder="确认密码" onBlur={this.handleConfirmBlur} />
                            )}
                        </FormItem>
                        <FormItem>
                            <a className="login-form-forgot" href="" style={{float: 'right'}}>返回</a>
                            <Button type="primary" htmlType="submit" className="login-form-button" style={{width: '100%'}}>
                                确认
                            </Button>
                        </FormItem>
                    </Form>
                </div>
            </div>

        );
    }
}

const mapStateToPorps = state => {
    const { auth } = state.httpData;
    return { auth };
};
const mapDispatchToProps = dispatch => ({
    fetchData: bindActionCreators(fetchData, dispatch),
    receiveData: bindActionCreators(receiveData, dispatch)
});


export default connect(mapStateToPorps, mapDispatchToProps)(Form.create()(Change));