import React from 'react';
import { Form, Icon, Input, Button, Checkbox, message } from 'antd';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import { fetchData, receiveData } from '@/action';
import Scecuity from './Scecuity'

const FormItem = Form.Item;

class Forget extends React.Component {
    constructor (props) {
        super(props)
        this.state = {
            decide:{
                confirm:false,
                result:false
            }
        }
    }
    componentWillMount() {
        const { receiveData } = this.props;
        receiveData(null, 'auth');
    }
    
    callbackConfResult = (newData) => {
        this.setState({
            decide:newData
        });
     }

    handleSubmit = (e) => {
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
              //判断验证码是否填写
        if(!this.state.decide.confirm){
        message.error('请输入验证码');
            return
        }
        //判断验证码是否填写正确
        if(!this.state.decide.result){
        message.error('验证码错误');
            return
        }
        if (!err) {
            const { router } = this.props;
            router.push('/change');
        }
        });
    };
    render() {
        const { getFieldDecorator } = this.props.form;
        return (
            <div className="login">
                <div className="login-form" >
                    <div className="login-logo">
                        <span>找回密码</span>
                    </div>
                    <Form onSubmit={this.handleSubmit} style={{maxWidth: '300px'}}>
                        <FormItem>
                            {getFieldDecorator('userName', {
                                rules: [{ required: true,
                                pattern: /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/,
                                message: 'The input is not valid E-mail!',
                                 }],
                            })(
                                <Input prefix={<Icon type="user" style={{ fontSize: 13 }} />} placeholder="邮箱" />
                            )}
                        </FormItem>
                        <Scecuity
                         callbackConfResult={this.callbackConfResult}/>
                        <FormItem>
                            <a className="login-form-forgot" href="" style={{float: 'right'}}>返回</a>
                            <Button type="primary" htmlType="submit" className="login-form-button" style={{width: '100%'}}>
                                确认
                            </Button>
                          
                        </FormItem>
                    </Form>
                </div>
            </div>

        );
    }
}

const mapStateToPorps = state => {
    const { auth } = state.httpData;
    return { auth };
};
const mapDispatchToProps = dispatch => ({
    fetchData: bindActionCreators(fetchData, dispatch),
    receiveData: bindActionCreators(receiveData, dispatch)
});


export default connect(mapStateToPorps, mapDispatchToProps)(Form.create()(Forget));