import React from 'react';
import { Form, Icon, Input, Button, Checkbox, message } from 'antd';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import logo from '../../style/imgs/logo_big.png';
import { fetchData, receiveData } from '@/action';
import Scecuity from './Scecuity'

const FormItem = Form.Item;

const user ={
    manager:{
        userName:'123@163.com',password:'admin123'
    },
    visitor :{
        userName:'124@163.com',password:'guest123'
    }
}
class Login extends React.Component {
    constructor (props) {
        super(props)
        this.state = {
        decide:{
            confirm:false,
            result:false
        }
    }
  }
    
    componentWillMount() {
        const { receiveData } = this.props;
        receiveData(null, 'auth');
    }
    componentWillReceiveProps(nextProps) {
        const { auth: nextAuth = {} } = nextProps;
        const { router } = this.props;
        if (nextAuth.data && nextAuth.data.uid) {   // 判断是否登陆
            localStorage.setItem('user', JSON.stringify(nextAuth.data));
            router.push('/app/dashboard/index');
        }
    }
    
    callbackConfResult = (newData) => {
        this.setState({
            decide:newData
        });
     }
 
    handleSubmit = (e) => {
        let correct=false;
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            //判断验证码是否填写
            if(!this.state.decide.confirm){
                message.error('请输入验证码');
                    return
            }
            //判断验证码是否填写正确
            if(!this.state.decide.result){
                message.error('验证码错误');
                    return
            } 
            //判断账号或密码是否正确
            for(var key in user){
                
                // user[key]
                if(user[key].userName==values.userName){
                    if(user[key].password==values.password){
                        correct=true
                    }
                }
            }  
            if(!correct){
                message.error('账号或密码错误');
                return 
            }    
            if (!err) {
                console.log('Received values of form: ', values);
                const { fetchData } = this.props;
                if (values.userName == user.manager.userName && values.password == user.manager.password ) fetchData({funcName: 'admin', stateName: 'auth'});
                if (values.userName ==user.visitor.userName && values.password == user.visitor.password) fetchData({funcName: 'guest', stateName: 'auth'});
                //if (values.userName === '123@163.com' && values.password === 'admin123' ) fetchData({funcName: 'admin', stateName: 'auth'});
                //if (values.userName === '124@163.com' && values.password === 'guest123' ) fetchData({funcName: 'guest', stateName: 'auth'});
                // if (values.userName === 'admin' && values.password === 'admin' && confirm) fetchData({funcName: 'admin', stateName: 'auth'});
                // if (values.userName === 'guest' && values.password === 'guest' && confirm) fetchData({funcName: 'guest', stateName: 'auth'});
                }
        });
    };
    reghandleOk = () => {
        const { router } = this.props;
        router.push('/register');
    }
    forgetOk = () => {
        const { router } = this.props;
        router.push('/forget');
    }
    render() {
        const { getFieldDecorator, getFieldsError, getFieldError, isFieldTouched } = this.props.form;
        return (
            <div className="login">
                <div className="login-form" >
                    <div className="login-logo">
                        <img src={logo} alt="头像" />
                        <span>登录</span>
                    </div>
                    <Form onSubmit={this.handleSubmit} style={{maxWidth: '300px'}}>
                        <FormItem>
                            {getFieldDecorator('userName', {
                                rules: [{ required: true,
                                pattern: /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/,
                                message: 'The input is not valid E-mail!',
                                }],
                            })(
                                <Input prefix={<Icon type="user" style={{ fontSize: 13 }} />} placeholder="管理员123@163.com，游客124@163.com" />
                            )}
                        </FormItem>
                        <FormItem>
                            {getFieldDecorator('password', {
                                rules: [{ required: true,
                                pattern : /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8}/,
                                message: '密码有误'
                                }],
                                
                            })(
                                <Input prefix={<Icon type="lock" style={{ fontSize: 13 }} />} type="password" placeholder="管理员密码admin123，游客密码guest123" />
                            )}
                        </FormItem>
                        <Scecuity
                        callbackConfResult={this.callbackConfResult}
                        />
                        <FormItem>
                            {getFieldDecorator('remember', {
                                valuePropName: 'checked',
                                initialValue: true,
                            })(
                                <Checkbox>记住我</Checkbox>
                            )}
                            <span className="login-form-forgot" style={{float: 'right',cursor:'pointer',color:'#0080ff'}} onClick={this.forgetOk}>忘记密码</span>
                            <Button type="primary" htmlType="submit" className="login-form-button" style={{width: '100%'}}>
                                登录
                            </Button>
                            或 <span onClick={this.reghandleOk} style={{cursor:'pointer',color:'#0080ff'}}><u>现在就去注册!</u></span>
                        </FormItem>
                    </Form>
                </div>
            </div>

        );
    }
}

const mapStateToPorps = state => {
    const { auth } = state.httpData;
    return { auth };
};
const mapDispatchToProps = dispatch => ({
    fetchData: bindActionCreators(fetchData, dispatch),
    receiveData: bindActionCreators(receiveData, dispatch)
});


export default connect(mapStateToPorps, mapDispatchToProps)(Form.create()(Login));