import React, { Component } from 'react';
import {Form, Input, Tooltip, Icon, Cascader, Select, Row, Col, Checkbox, Button } from 'antd';
import {className} from '../../style/register.less'
import city from '../../utils/city'
import Agree from './Agree'


let disabled = true
const FormItem = Form.Item;
const Option = Select.Option;

class BasicForms extends Component {
    constructor(props) {
        super(props)
        this.state = {
            visibles : false,
            change:false
        }
  }
    state = {
        confirmDirty: false,
        disabled : true
    };
  
    handleSubmit = (e) => {
        const { router } = this.props;
        e.preventDefault();
        this.props.form.validateFieldsAndScroll((err, values) => {
            if (!err) {
                let data = {
                    email : this.state.email,
                    password: this.state.password,
                    confirm : this.state.confirm,
                    nickname : this.state.nickname,
                    residence : this.state.residence,
                    phone : this.state.phone,
                    captcha : this.state.captcha,
                }
                fetch({
                    method: 'GET',
                    headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json'
                    },
                    body: JSON.stringify(data)
                })
                .then(function(data) {
                    router.push('/login');
           
                })
                .catch(function(error) {        
                    console.log('request failed', error)
                })
                console.log('Received values of form: ', values);
            }
        });
    };
    handleConfirmBlur = (e) => {
        const value = e.target.value;
        this.setState({ confirmDirty: this.state.confirmDirty || !!value });
    };
    checkPassword = (rule, value, callback) => {
        const form = this.props.form;
        if (value && value !== form.getFieldValue('password')) {
            callback('Two passwords that you enter is inconsistent!');
        } else {
            callback();
        }
    };
    checkConfirm = (rule, value, callback) => {
        const form = this.props.form;
        if (value && this.state.confirmDirty) {
            form.validateFields(['confirm'], { force: true });
        }
        callback();
    };
    callbackConfAgree=(nueData)=>{
        this.setState({
            visibles: nueData,
        });
    }
    callbackConfChange=(nueData)=>{
        this.setState({
            change: nueData,
        });
    }
    change=()=>{
        console.log(110)
        if(this.state.change && this.state.visibles){
            disabled = false
        }else{
            disabled = true
        }
      }
 
    render() {
        const { getFieldDecorator } = this.props.form;
        const formItemLayout = {
            labelCol: {
                xs: { span: 24 },
                sm: { span: 8 },
            },
            wrapperCol: {
                xs: { span: 24 },
                sm: { span: 14 },
            },
        };
        const tailFormItemLayout = {
            wrapperCol: {
                xs: {
                    span: 24,
                    offset: 0,
                },
                sm: {
                    span: 14,
                    offset: 8,
                },
            },
        };
        const prefixSelector = getFieldDecorator('prefix', {
            initialValue: '86',
        })(
            <Select className="icp-selector" style={{width: '60px'}}>
                <Option value="86">+86</Option>
            </Select>
        );

 
    this.change()
        return (
        <div className="register">
            <div className="register-form" >
                <div className="register-logo">
                    <span>注册用户</span>
                </div>
                  <a href='/login' style={{marginLeft: '60px', color:'#0080ff'}}>>>已有账户</a>
                <Form onSubmit={this.handleSubmit}>
                    <FormItem
                        {...formItemLayout}
                        label="邮箱"
                        hasFeedback
                    >
                        {getFieldDecorator('email', {
                            rules: [{
                                type: 'email', message: '请输入合理的邮箱地址!',
                            }, {
                                required: true, 
                                pattern: /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(.[a-zA-Z0-9_-])+/,
                                message: '请输入邮箱地址!',
                            }],
                        })(
                            <Input />
                        )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="密码"
                        hasFeedback
                    >
                        {getFieldDecorator('password', {
                            rules: [{
                                required: true,
                                pattern : /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8}/,
                                message: '请输入密码!',
                            }, {
                                validator: this.checkConfirm,
                            }],
                        })(
                            <Input type="password" />
                        )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="确认密码"
                        hasFeedback
                    >
                        {getFieldDecorator('confirm', {
                            rules: [{
                                required: true,
                                pattern : /^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]{8}/,
                                message: '请确认你的密码!',
                            }, {
                                validator: this.checkPassword,
                            }],
                        })(
                            <Input type="password" onBlur={this.handleConfirmBlur} />
                        )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label={(
                            <span>
                                昵称&nbsp;
                                <Tooltip title="别人怎么称呼你?">
                                <Icon type="question-circle-o" />
                                </Tooltip>
                            </span>
                        )}
                        hasFeedback
                    >
                        {getFieldDecorator('nickname', {
                            rules: [{ required: true, message: '请输入昵称!', whitespace: true }],
                        })(
                            <Input />
                        )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="常住地址"
                    >
                        {getFieldDecorator('residence', {
                            initialValue: ['zhejiang', 'hangzhou', 'xihu'],
                            rules: [{ type: 'array', required: true, message: '请选择你的常住地址!' }],
                        })(
                            <Cascader options={city} />
                        )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="电话号码"
                    >
                        {getFieldDecorator('phone', {
                            rules: [{ 
                                required: true,
                                pattern: /^1[34578]\d{9}$/,
                                message: '请输入你的电话号码!' }],
                        })(
                            <Input addonBefore={prefixSelector} />

                        )}
                    </FormItem>
                    <FormItem
                        {...formItemLayout}
                        label="验证码"
                        extra="我们必须确认你不是机器人."
                    >
                        <Row gutter={8}>
                            <Col span={12}>
                                {getFieldDecorator('captcha', {
                                    rules: [{ required: true,
                                    pattern : /([0-9]{4})/,
                                    message: '请输入你获取的验证码!' }],
                                })(
                                    <Input size="large" />
                                )}
                            </Col>
                            <Col span={12}>
                                <Button size="large">获取验证码</Button>
                            </Col>
                        </Row>
                    </FormItem>
                    <FormItem {...tailFormItemLayout} style={{ marginBottom: 8 }}>
                        {getFieldDecorator('agreement', {
                            valuePropName: 'checked',
                        })(
                             <Agree
                             callbackConfChange={this.callbackConfChange}
                             callbackConfAgree={this.callbackConfAgree}
                           //   onChange={this.state.disabledChange}
                              />
                           // <Checkbox onChange={disabledChange}>我已经阅读过 <a href="">协议</a></Checkbox>
                        )}
                    </FormItem>
                    <FormItem {...tailFormItemLayout}>
                        <Button type="primary" htmlType="submit"  onChange={this.disabledChange} disabled={disabled}  size="large" >注册</Button>
                    </FormItem>
                </Form>
            </div>
        </div>
        )
    }
}

const BasicForm = Form.create()(BasicForms);

export default BasicForm;