import React from 'react';
import * as ReactDOM from "react-dom";
import { Form,Row, Col, Table, Input, Button,Popconfirm,DatePicker,TimePicker ,Select ,Cascader  } from 'antd';
import { workData } from '../../axios';
import { Link,hashHistory } from 'react-router';
import {exportExcel} from '../../simpleXlsx';
import WorkMap from './WorkMap';
import  ol from 'openlayers';
import city from '../../utils/city'

//机具管理页面
const Option = Select.Option;
const Search = Input.Search
const FormItem = Form.Item;
const dateFormat = 'YYYY/MM/DD';
const ColProps = {
    xs: 24,
    sm: 12,
    style: {
        marginBottom: 16,
    },
}

var pointLayer = new ol.layer.Vector({
    source: new ol.source.Vector()
});
var circleLayer = new ol.layer.Vector({
    source: new ol.source.Vector()
});
var googleMapLayer = new ol.layer.Tile({  
    source: new ol.source.XYZ({  
        url: 'http://khm{0-3}.googleapis.com/kh?v=742&hl=pl&&x={x}&y={y}&z={z}',
        imagerySet: "Google Satellite"
    })  
}); 
//选择年份  
let dateYear = []
let work = []
class CheckMaps extends React.Component {
    constructor (props) {
        super(props)
        this.state = {
        }
    }
    state = {
        search:'',
        jobDate:'',
        area:'',
        jobtype:'',
    };
    componentDidMount(){
        var map = new ol.Map({  
            layers: [
                googleMapLayer,
                circleLayer
            ],  
            view: new ol.View({  
                center: [121.522448, 31.0584447],  
                projection: 'EPSG:4326',  
                zoom: 10  
            }),  
            target: 'map'  
        }); 
        if(window.localStorage['workCentre']){
            let newdata=JSON.parse(window.localStorage['workCentre'])
             console.log(newdata,'newdata')
            let jobDate = []
            for(var i = 0; i<newdata.length;i++){
                if (jobDate.indexOf(newdata[i].jobDate) == -1){
                    jobDate.push(newdata[i].jobDate); 
                } 
            }
           
            for(var i = 0; i < jobDate.length; i++){
                dateYear.push(<Option key={jobDate[i]}>{jobDate[i]}</Option>);
            }
            let jobType = []
            for(var i = 0; i<newdata.length;i++){
                if (jobType.indexOf(newdata[i].jobType) == -1){
                    jobType.push(newdata[i].jobType); 
                } 
            }
           
            for(var i = 0; i < jobType.length; i++){
                work.push(<Option key={jobType[i]}>{jobType[i]}</Option>);
            }
        }
    }
    handleSubmit = (e) => {
        const { router } = this.props;
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (!err) {
                console.log('Received values of form: ', values);
            }
        })
    }
    onChange(value) {
        console.log(value);
    }

     //取消重置
    handleReset = () => {
        this.props.form.resetFields();
    }
    render() {
        const { getFieldDecorator } = this.props.form;
        const formItemLayout = {
            labelCol: {
                xs: { span:12 },
                sm: { span: 6 },
            },
            wrapperCol: {
                xs: { span: 12 },
                sm: { span: 12 },
            },
        };
        const tailFormItemLayout = {
            wrapperCol: {
                xs: {
                    span: 12,
                    offset: 0,
                },
                sm: {
                    span: 14,
                    offset: 8,
                },
            },
        };
        let data=this.state.data     

        return (
            <div>
                <Form onSubmit={this.handleSubmit}>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        >
                        {getFieldDecorator('search', {
                            setFieldsValue:this.state.search,
                        rules: [{ 
                        }],
                        })(
                        <Search
                        size="large"
                        ref={ele => this.searchInput = ele}           
                        onChange={this.onInputChange}
                        onSearch={this.onSearch}
                        placeholder="输入关键字搜索"/>
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="选择年份"
                        >
                        {getFieldDecorator('jobDate', {
                            setFieldsValue:this.state.jobDate,
                        })(
                            <Select
                                showSearch
                                onChange={this.handleSelectChange} 
                                placeholder="请选择年份"
                                optionFilterProp="children"
                            >
                                {dateYear}
                            </Select>
                          
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="选择区域"
                        >
                        {getFieldDecorator('area', {
                            setFieldsValue:this.state.area,
                        })(
                        <Cascader
                            options={city}
                            onChange={this.onChange}
                            placeholder="请选择省市区"
                            changeOnSelect 
                            showSearch
                        />
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="作业类型"
                        >
                        {getFieldDecorator('jobtype', {
                            rules: [{ }],
                           
                        })(
                        <Select
                            showSearch
                            style={{ width:"100%"}}
                            placeholder="请选择车牌号"
                            optionFilterProp="children"
                        >
                            {work}
                        </Select>
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6} offset = {16}> 
                        <FormItem style={{float:'right',right:'15%'}} {...tailFormItemLayout}>
                            <Button style={{position: 'absolute',top: '0px',left:'-80px'}} type="primary" htmlType="submit" size="large" >查询</Button>
                            <Button style={{position: 'absolute',top: '0px',right:'-80px'}} type="primary" onClick={this.handleReset} size="large" >重置</Button> 
                        </FormItem>
                    </Col>
                </Form> 
                <div>
                    
                    <div id="map" style={{height:'500px',clear:'both',paddingTop:'30px'}}></div>
                </div>
                

            </div>
        );
    }
    }

const CheckMap = Form.create()(CheckMaps);
export default CheckMap;
