import React from 'react';
import { Form,Row, Col, Table, Input, Button,Popconfirm,DatePicker,TimePicker ,Select ,Cascader  } from 'antd';
import { workData } from '../../axios';
import { Link,hashHistory } from 'react-router';
import {exportExcel} from '../../simpleXlsx';
import moment from 'moment';
import WorkMap from './WorkMap';
import city from '../../utils/city'

//地块管理页面
const Option = Select.Option;
const Search = Input.Search
const FormItem = Form.Item;
const dateFormat = 'YYYY/MM/DD';
const ColProps = {
    xs: 24,
    sm: 12,
    style: {
        marginBottom: 16,
    },
}
let index=0
let dateYear = []  //年份
let job = []   //作业类型
class PlotManageLists extends React.Component {
    constructor (props) {
        super(props)
        this.state = {
        }
    }
    state = {
        filterDropdownVisible: false,
        data:[],
        searchText: '',
        jobDate: '',
        filtered: false,
        startValue: null,
        endValue: null,
        endOpen: false,
    };
    componentDidMount(){
        if(window.localStorage['workCentre']){
            //本地缓存
            let newdata=JSON.parse(window.localStorage['workCentre'])
            //年份筛选
            let jobDate = []
            for(var i = 0; i<newdata.length; i++){
                if (jobDate.indexOf(newdata[i].jobDate) == -1){
                    jobDate.push(newdata[i].jobDate); 
                } 
            }
            for(var i = 0; i < jobDate.length; i++){
                dateYear.push(<Option key={jobDate[i]}>{jobDate[i]}</Option>);
            }
            //作业类型筛选
            let jobType = []
            for(var i = 0; i<newdata.length; i++){
                if (jobType.indexOf(newdata[i].jobType) == -1){
                    jobType.push(newdata[i].jobType); 
                } 
            }
            for(var i = 0; i < jobType.length; i++){
                job.push(<Option key={jobType[i]}>{jobType[i]}</Option>);
            }
            this.setState({
                data:newdata,     
            })   
            
        }else{
            //后台数据
            workData().then(npm => {
                let newdata = npm.data
                this.setState({
                    data:newdata,       
                })  

                //年份筛选
                let jobDate = []
                for(var i = 0; i<newdata.length; i++){
                    if (jobDate.indexOf(newdata[i].jobDate) == -1){
                        jobDate.push(newdata[i].jobDate); 
                    } 
                }
                for(var i = 0; i < jobDate.length; i++){
                    dateYear.push(<Option key={jobDate[i]}>{jobDate[i]}</Option>);
                } 

                //作业类型筛选
                let jobType = []
                for(var i = 0; i<newdata.length; i++){
                    if (jobType.indexOf(newdata[i].jobType) == -1){
                        jobType.push(newdata[i].jobType); 
                    } 
                }
                for(var i = 0; i < jobType.length; i++){
                    job.push(<Option key={jobType[i]}>{jobType[i]}</Option>);
                }
                localStorage.setItem('workCentre',JSON.stringify(newdata))
                
            })   
        }
    }

    //form表单
    handleSubmit = (e) => {
        let _this=this
        const { router } = this.props;
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (!err) {
                console.log('Received values of form: ', values);
                let newdata=JSON.parse(window.localStorage['workCentre']) 
                const { searchText,jobDate,data,startValue,endValue } = this.state;
                // 声明一个全局匹配 忽略大小写的正则
                // 正则内容要看searchText是什么 
                // g表示global全局搜索
                // i表示ignore case 忽略大小写
                const reg = new RegExp(searchText,'gi'); 
                let  smallData;
                let datas = newdata.map((record) => {
                    let matchs
                    const plotId = record.plotId.match(reg) //筛选地块ID
                        smallData = record.WorkList.map((records)=>{
                            // console.log(records,'records')
                            const equipment = records.equipment.match(reg)   //筛选设备ID
                            const Car = records.Car.match(reg)   //筛选作业状态
                            matchs= Car||equipment
                                if (!matchs) {
                                    return null;
                                }
                                return {
                                    ...record,     
                                };
                            }).filter(records => !!records)
                    const match = plotId
                    if(smallData.length!=0){
                        _this.setState({
                            index:true,
                            data1:smallData,
                        })
                        // console.log(this.state.data1,'data1')
                    }else{
                        index:false
                    }
                    if (!match&&!matchs) {
                        return null;
                    }
                    return {
                        ...record,     
                    };
             
             }).filter(record => !!record)
                //作业日期的内容筛选
                // datas = datas.map((record)=> {
                //     let  match
                //     if(new Date(record.jobDate).getTime()==new Date(jobDate).getTime()){
                //         match=record
                //     }
                //     if (!match) {
                //         return null;
                //     }
                //     return {
                //         ...record,     
                //     }
                // }).filter(record => !!record)
                // //开始时间的内容筛选
                // const regTime = new Date(startValue).getTime()
                // const endRegTime = new Date(endValue).getTime()                
                // datas = datas.map((record)=> {
                //     const startVal = record.jobTime.split("/")
                //     const startDate =  new Date(jobDate + ' ' + startVal[0]).getTime()
                //     const endDate = new Date(jobDate + ' ' + startVal[1]).getTime()
                //     console.log(startDate,endDate,1000)
                //     let match
                //     if(regTime < startDate < endDate && endDate < endRegTime){
                //         match=record
                //     }
                //     if (!match) {
                //         return null;
                //     }
                //     return {
                //         ...record,     
                //     };
                // }).filter(record => !!record) 
                this.setState({
                    filterDropdownVisible: false,
                    filtered: !!searchText,
                    data:datas
                });
            }
        });
    };

     //获取搜索框输入的内容
    onInputChange = (e) => {
        this.setState({ searchText: e.target.value });
       
    }
    //获取作业日期框的内容
    onWorkChange = (e,value) => {
        this.setState({
            jobDate:value,
        });
        console.log(Date(value),9000)
    }


    // //查看   跳转和数据传递
    // handleClick = (key) => {
    //     const dataSource = [...this.state.data];
    //     let ExaData = dataSource.filter(item => item.key == key)
    //     hashHistory.push({
    //         state:ExaData,
    //         pathname: '/app/machineTool/MachineDetail',
    //     })
    // }  

    //导出文件
    exportClick=()=> {
        let excelResult = this.state.data;
        let excelData = [];
        excelData[0] = ['地块ID','地块名称','地块面积','地块中心点','所属区域','轮作次数'];
        //遍历数据
        excelResult.forEach(function(e, i) {
            let n =i+1;
            excelData[n] = [];
            excelData[n][0] = e.plotId || '--';
            excelData[n][1] = e.plotName || '--';
            excelData[n][2] = e.plotArea || '--';
            excelData[n][3] = e.plotCentre || '--';
            excelData[n][4] = e.region || '--';
            excelData[n][5] = e.frequency || '--';
        });
        //文件名
        let fileName =  '地块管理-列表';
        exportExcel(excelData, fileName);
    }


    onChange = (field, value) => {
        this.setState({
            [field]: value,
        });
    }

    handleStartOpenChange = (open) => {
        if (!open) {
        this.setState({ 
            endOpen: true 
        });
        }
    }
    handleEndOpenChange = (open) => {
        this.setState({ endOpen: open });
    }

    handleChange=(pagination, filters, sorter,data)=> {
    }
    expandedRowRender = ( target ) =>{
        const columns = [
            { title:'时间', dataIndex: 'year', key: 'year' },
            { title:'作业类型', dataIndex: 'jobType', key: 'jobType' },
            { title:'作业亩数', dataIndex: 'plotArea', key: 'plotArea'},
            { title:'车牌号', dataIndex: 'Car', key: 'Car'},
            { title:'设备ID', dataIndex: 'equipment', key: 'equipment'},
            { title:'机具ID', dataIndex: 'MachineID', key: 'MachineID'},
        ];
        let workList = target.WorkList
        console.log(workList,"workList")
        const data = [];
        for (let i = 0; i < workList.length; ++i) {
            data.push({
                key: i,
                year: workList[i].year,
                jobType: workList[i].jobType,
                plotArea: workList[i].plotArea,
                Car: workList[i].Car,
                equipment: workList[i].equipment,
                MachineID: workList[i].MachineID,
            });
        }
        return (
            <div>
                <Table 
                columns={columns}
                dataSource={data}
                pagination={false}
                />
                
            </div>
        );
    }

    handleSelectChange(value) {
        console.log(`selected ${value}`);
    }

    onChange(value, selectedOptions) {
        console.log(value, selectedOptions);
    }
    MapRowMessage = (key) =>{
        const dataSource = [...this.state.data];
        let ExaData = dataSource.filter(item => item.key == key)
         hashHistory.push({
             state:ExaData,
            pathname: '/app/workCentre/CheckMap',
        })
    }

    //取消重置
    handleReset = () => {
        this.props.form.resetFields();
    }
    // openMap = () =>{
    //     hashHistory.push({
    //         pathname: '/app/workCentre/CheckMap',
    //     })
    // }
    render() {
        const { getFieldDecorator } = this.props.form;
        const formItemLayout = {
            labelCol: {
                xs: { span:12 },
                sm: { span: 6 },
            },
            wrapperCol: {
                xs: { span: 12 },
                sm: { span: 12 },
            },
        };
        const tailFormItemLayout = {
            wrapperCol: {
                xs: {
                    span: 12,
                    offset: 0,
                },
                sm: {
                    span: 14,
                    offset: 8,
                },
            },
        };
        const { startValue, endValue, endOpen,jobDate } = this.state;
        let data=this.state.data     
        const columns = [{
                key: 'plotId',  
                title: '地块ID',
                dataIndex: 'plotId',
            }, {
                key: 'plotName',
                title: '地块名称',
                dataIndex: 'plotName',
            },{
                key: 'plotArea',
                title: '地块面积',
                dataIndex: 'plotArea',
            },{
                key: 'plotCentre',
                title: '地块中心点',
                dataIndex: 'plotCentre',
            },{
                key: 'region',
                title: '所属区域',
                dataIndex: 'region',
            },{
                key: 'frequency',
                title: '轮作次数',
                dataIndex: 'frequency',
            },{
                key: 'operation',
                title: '操作',
                dataIndex: 'operation',
                render: (text, record) => (
                    <a onClick={ () => this.MapRowMessage(record)} style={{cursor:"pointer"}}>查看</a>
                ) , 
        }];
        return (
            <div>
                <Form onSubmit={this.handleSubmit}>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        >
                        {getFieldDecorator('search', {
                            setFieldsValue:this.state.searchText,
                        rules: [{ 
                        }],
                        })(
                        <Search
                        size="large"
                        ref={ele => this.searchInput = ele}           
                        onChange={this.onInputChange}
                        onSearch={this.onSearch}
                        placeholder="输入关键字搜索"/>
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="选择年份"
                        >
                        {getFieldDecorator('year', {
                            setFieldsValue:this.state.year,
                        })(
                            <Select onChange={this.handleSelectChange} 
                                placeholder="请选择年份"
                                optionFilterProp="children">
                                {dateYear}
                            </Select>
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="选择区域"
                        >
                        {getFieldDecorator('area', {
                            setFieldsValue:startValue,
                        })(
                        <Cascader
                            options={city}
                            onChange={this.onChange}
                            placeholder="请选择省市区"
                            changeOnSelect 
                            showSearch
                        />
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="作业类型"
                        >
                        {getFieldDecorator('jobtype', {
                            setFieldsValue:endValue,
                        })(
                        <Select
                        placeholder="输选择作业类型"
                        onChange={this.handleSelectChange}>
                            {job}
                        </Select>
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={3} md={3} lg={3} xl={3}>
                        <FormItem
                        {...formItemLayout}
                        >
                        <Button type="default" onClick={this.exportClick}>导出至Excel</Button>
                        </FormItem>
                    </Col>
                    <Col sm={3} md={3} lg={3} xl={3} > 
                        <FormItem
                            {...formItemLayout}
                            >           
                            <Button type="default" onClick={this.MapRowMessage}>查看地图</Button>
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6} offset={10}> 
                        <FormItem {...tailFormItemLayout}>
                            <Button type="primary" style={{position: 'absolute',top: '0px',left:'-20px' }} htmlType="submit" size="large" >查询</Button>
                            <Button type="primary" style={{position: 'absolute',top: '0px',left:'50px'}} onClick={this.handleReset} size="large" >重置</Button> 
                        </FormItem>
                    </Col> 
                </Form> 
                <Col  sm={24} md={24} lg={24} xl={24}>
                <Table columns={columns} dataSource={this.state.index?this.state.data1:data} onChange={this.handleChange} expandedRowRender={this.expandedRowRender}
                    pagination={{
                        showSizeChanger: true,  //是否显示可以设置几条一页的选项
                        showQuickJumper:true,
                        onShowSizeChange(current, pageSize) {  //当几条一页的值改变后调用函数，current：改变显示条数时当前数据所在页；pageSize:改变后的一页显示条数
                            console.log(current, pageSize);
                        },
                        onChange(pageNumber) {
                            console.log('Page: ', pageNumber);
                        }
                    }}
                />
                </Col>
                
            </div>
        );
    }
    }

const PlotManageList = Form.create()(PlotManageLists);
export default PlotManageList;
