import React from 'react';
import { Form,Row, Col, Table, Input, Button,Popconfirm,DatePicker,TimePicker   } from 'antd';
import { workData } from '../../axios';
import { Link,hashHistory } from 'react-router';
import {exportExcel} from '../../simpleXlsx';
import moment from 'moment';
import WorkMap from './WorkMap';

//机具管理页面

const Search = Input.Search
const FormItem = Form.Item;
const dateFormat = 'YYYY/MM/DD';    
const ColProps = {
    xs: 24,
    sm: 12,
    style: {
        marginBottom: 16,
    },
}
let index=0
class WorkManageLists extends React.Component {
    constructor (props) {
        super(props)
        this.state = {
        }
    }
    state = {
        filterDropdownVisible: false,
        data:[],
        searchText: '',
        jobDate: '',
        filtered: false,
        startValue: null,
        endValue: null,
        endOpen: false,
    };
    componentDidMount(){
        if(window.localStorage['workCentre']){
            //本地缓存
            let newdata=JSON.parse(window.localStorage['workCentre'])
            //筛选作业类型
            let jobName = []
            for(var i = 0; i < newdata.length; i++){
                if (jobName.indexOf(newdata[i].jobType) == -1){
                    jobName.push(newdata[i].jobType); 
                } 
            }
            let jobList = []
            for(let i=0;i<jobName.length;i++){
                let jobType={ text: jobName[i], value: jobName[i] }
                jobList.push(jobType)
            }
            //筛选作业状态
            let states = []
            for(var i = 0; i < newdata.length; i++){
                if (states.indexOf(newdata[i].jobState) == -1){
                    states.push(newdata[i].jobState); 
                } 
            }
            let stateList = []
            for(let i=0;i<states.length;i++){
                let jobState={ text: states[i], value: states[i] }
                stateList.push(jobState)
            }
            this.setState({
                data:newdata,     
                jobList:jobList,
                stateList:stateList     
            })   
            
        }else{
            //后台数据
            workData().then(npm => {
                let newdata = npm.data
                //筛选作业类型
                console.log(npm,'newdata')
                let jobName = []
                for(var i = 0; i < newdata.length; i++){
                    if (jobName.indexOf(newdata[i].jobType) == -1){
                        jobName.push(newdata[i].jobType); 
                    } 
                }
                let jobList = []
                for(let i=0;i<jobName.length;i++){
                    let jobType={ text: jobName[i], value: jobName[i] }
                    jobList.push(jobType)
                }
                //筛选作业状态
                let states = []
                for(var i = 0; i < newdata.length; i++){
                    if (states.indexOf(newdata[i].jobState) == -1){
                        states.push(newdata[i].jobState); 
                    } 
                }
                let stateList = []
                for(let i=0;i<states.length;i++){
                    let jobState={ text: states[i], value: states[i] }
                    stateList.push(jobState)
                }
                
                this.setState({
                    data:newdata,     
                    jobList:jobList,
                    stateList:stateList    
                })      
                localStorage.setItem('workCentre',JSON.stringify(newdata))
                
            })   
        }
    }

    //form表单
    handleSubmit = (e) => {
        const { router } = this.props;
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (!err) {
                console.log('Received values of form: ', values);
                let newdata=JSON.parse(window.localStorage['workCentre']) 
                const { searchText,jobDate,data,startValue,endValue } = this.state;
                // 声明一个全局匹配 忽略大小写的正则
                // 正则内容要看searchText是什么 
                // g表示global全局搜索
                // i表示ignore case 忽略大小写
                const reg = new RegExp(searchText,'gi');  
                let datas = newdata.map((record) => {
                    const Car = record.bindingCar.match(reg) //筛选绑定车辆
                    const jobType = record.jobType.match(reg)   //筛选作业类型
                    const jobState = record.jobState.match(reg)   //筛选作业状态
                    const match = Car||jobType||jobState
                    if (!match) {
                        return null;
                    }
                    return {
                        ...record,     
                    };
                }).filter(record => !!record)
                //作业日期的内容筛选
                datas = datas.map((record)=> {
                    let  match
                    if(new Date(record.jobDate).getTime()==new Date(jobDate).getTime()){
                        match=record
                    }
                    if (!match) {
                        return null;
                    }
                    return {
                        ...record,     
                    }
                }).filter(record => !!record)
                //开始时间的内容筛选
                const regTime = new Date(startValue).getTime()
                const endRegTime = new Date(endValue).getTime()                
                // new Date(jobDate)
                // let target=[]
                // let shijian =(date)=>{
                //     let Hours=date.getHours()
                //     let Minutes=date.getMinutes()
                //     let Seconds=date.getSeconds()
                //     if(Hours<10){
                //         Hours="0"+Hours
                //     }
                //     if(Minutes<10){
                //         Minutes="0"+Minutes
                //     }
                //     if(Seconds<10){
                //         Seconds="0"+Seconds
                //     }
                //     return     " "+Hours+":"+Minutes+":"+Seconds          
                // }
                datas = datas.map((record)=> {
                    const startVal = record.jobTime.split("/")
                    const startDate =  new Date(jobDate + ' ' + startVal[0]).getTime()
                    const endDate = new Date(jobDate + ' ' + startVal[1]).getTime()
                    console.log(startDate,endDate,1000)
                    let match
                    if(regTime < startDate < endDate && endDate < endRegTime){
                        match=record
                    }
                    if (!match) {
                        return null;
                    }
                    return {
                        ...record,     
                    };
                }).filter(record => !!record) 
                this.setState({
                    filterDropdownVisible: false,
                    filtered: !!searchText,
                    data:datas
                });
            }
        });
    };

     //获取搜索框输入的内容
    onInputChange = (e) => {
        this.setState({ searchText: e.target.value });
       
    }
    //获取作业日期框的内容
    onWorkChange = (e,value) => {
        // this.onChange({jobDate:value});
        // // this.onChange({ dateValue:e.target.value});
        //  console.log(value,9000)
        this.setState({
            jobDate:value,
        });
        console.log(Date(value),9000)
    }

    //约束开始时间
    disabledStartDate = (startValue) => {
        const endValue = this.state.endValue;
        if (!startValue || !endValue) {
        return false;
        }
        return startValue.valueOf() > endValue.valueOf();
    }

    //约束结束时间
    disabledEndDate = (endValue) => {
        const startValue = this.state.startValue;
        if (!endValue || !startValue) {
        return false;
        }
        return endValue.valueOf() <= startValue.valueOf();
    }

    // //查看   跳转和数据传递
    // handleClick = (key) => {
    //     const dataSource = [...this.state.data];
    //     let ExaData = dataSource.filter(item => item.key == key)
    //     hashHistory.push({
    //         state:ExaData,
    //         pathname: '/app/machineTool/MachineDetail',
    //     })
    // }  

    //导出文件
    exportClick=()=> {
        let excelResult = this.state.data;
        let excelData = [];
        excelData[0] = ['作业日期','设备ID','绑定车辆','绑定机具','作业类型','作业地块','作业面积','合格面积','作业状态','作业时间','作业地点'];
        //遍历数据
        excelResult.forEach(function(e, i) {
            let n =i+1;
            excelData[n] = [];
            excelData[n][0] = e.jobDate || '--';
            excelData[n][1] = e.equipment || '--';
            excelData[n][2] = e.bindingCar || '--';
            excelData[n][3] = e.bindingMachine || '--';
            excelData[n][4] = e.jobType || '--';
            excelData[n][5] = e.jobSite || '--';
            excelData[n][6] = e.workingArea || '--';
            excelData[n][7] = e.qualifiedArea || '--';
            excelData[n][8] = e.jobState || '--';
            excelData[n][9] = e.jobTime || '--';
            excelData[n][10] = e.location || '--';
        });
        //文件名
        let fileName =  '作业管理-列表';
        exportExcel(excelData, fileName);
    }

    // onChange=( searchText )=> {
    //     let attribute='expirationdate'
    //     this.timeFilter(attribute,searchText)
    // }
    onChange = (field, value) => {
        this.setState({
            [field]: value,
        });
    }

    onStartChange = (value) => {
        this.onChange('startValue', new Date(value));
        // console.log(new Date(value).toLocaleTimeString(),8000)
    }

    onEndChange = (value) => {
        this.onChange('endValue', new Date(value));
        // console.log(new Date(value).toLocaleTimeString(),7000)
    }

    handleStartOpenChange = (open) => {
        if (!open) {
        this.setState({ 
            endOpen: true 
        });
        }
    }

    handleEndOpenChange = (open) => {
        this.setState({ endOpen: open });
    }

    handleChange=(pagination, filters, sorter,data)=> {
    }
    expandedRowRender = (record) =>{ 
        let Skey = record.key

        return <WorkMap Skey={Skey}/>
    }

    //取消重置
    handleReset = () => {
        this.props.form.resetFields();
    }

    onExpandedRowsChange(expandedRows){
        if(expandedRows.length>1){
            expandedRows.shift()
        }
        
        console.log(expandedRows,'expandedRows')
    }
    render() {
        const { getFieldDecorator } = this.props.form;
        const formItemLayout = {
            labelCol: {
                xs: { span:12 },
                sm: { span: 6 },
            },
            wrapperCol: {
                xs: { span: 12 },
                sm: { span: 12 },
            },
        };

        const tailFormItemLayout = {
            labelCol: {
                xs: { span:12 },
                sm: { span: 6 },
            },
            wrapperCol: {
                xs: { span: 12 },
                sm: { span: 12 },
            },
        };
        const { startValue, endValue, endOpen,jobDate } = this.state;
        let data=this.state.data
        let jobList = this.state.jobList
        let stateList = this.state.stateList        
        const columns = [{
                key: 'jobDate',  
                title: '作业日期',
                dataIndex: 'jobDate',
            }, {
                key: 'equipment',
                title: '设备ID',
                dataIndex: 'equipment',
            },{
                key: 'bindingCar',
                title: '绑定车辆',
                dataIndex: 'bindingCar',
            },{
                key: 'bindingMachine',
                title: '绑定机具',
                dataIndex: 'bindingMachine',
            },{
                key: 'jobType',
                title: '作业类型',
                dataIndex: 'jobType',
                filters:jobList,
                onFilter: (value, record) =>{
                    return record.jobType.indexOf(value) === 0
                } ,
            },{
                key: 'jobSite',
                title: '作业地块',
                dataIndex: 'jobSite',
            }, {
                key: 'workingArea',
                title: '作业面积',
                dataIndex: 'workingArea',
            },{
                key: 'qualifiedArea',
                title: '合格面积',
                dataIndex: 'qualifiedArea',
            },{
                key: 'jobState',
                title: '作业状态',
                dataIndex: 'jobState',
                filters:stateList,
                onFilter: (value, record) =>{
                    return record.jobState.indexOf(value) === 0
                } ,
            },{
                key: 'jobTime',
                title: '作业时间',
                dataIndex: 'jobTime',
            },{
                key: 'locations',
                title: '作业地点',
                dataIndex: 'locations',
            },{
                // key: 'operation',
                // title: '操作',
                // dataIndex: 'operation',
                // render: (text, record) => (
                //     <a onClick={ () => this.MapRowMessage(record)} style={{cursor:"pointer"}}>查看</a>
                // ) , 
        }];
        return (
            <div>
                <Form onSubmit={this.handleSubmit}>

                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        >
                        {getFieldDecorator('search', {
                            setFieldsValue:this.state.searchText,
                        rules: [{ 
                        }],
                        })(
                        <Search
                        size="large"
                        ref={ele => this.searchInput = ele}           
                        onChange={this.onInputChange}
                        onSearch={this.onSearch}
                        placeholder="输入关键字搜索"/>
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        label="作业日期"
                        >
                        {getFieldDecorator('jobDate', {
                            setFieldsValue:this.state.jobDate,
                        })(
                        <DatePicker style={{ width:"100%"}} 
                        onChange={this.onWorkChange}
                        initialValue={moment(jobDate, dateFormat)} 
                        format={dateFormat} placeholder="请选择设备生产日期"/>            
                        )}
                        </FormItem>
                    </Col>
                    <Col  sm={6} md={6} lg={6} xl={6} >

                        <FormItem
                        {...formItemLayout}
                        label="开始时间"
                        >
                        {getFieldDecorator('startdate', {
                            setFieldsValue:startValue,
                        })(
                        <TimePicker
                        disabledDate={this.disabledStartDate}
                        style={{ width:"100%"}} 
                        use12Hours
                        format="HH:mm:ss"
                        placeholder="请输入开始时间"
                        onChange={this.onStartChange}
                        onOpenChange={this.handleStartOpenChange}
                        />
                        )}
                        </FormItem>
                    </Col>
                    <Col  sm={6} md={6} lg={6} xl={6} >

                        <FormItem
                        {...formItemLayout}
                        label="结束时间"
                        >
                        {getFieldDecorator('enddate', {
                            setFieldsValue:endValue,
                        })(
                        <TimePicker
                        disabledDate={this.disabledEndDate}
                        style={{ width:"100%"}} 
                        showTime
                        use12Hours
                        format="HH:mm:ss"
                        placeholder="请输入结束时间"
                        onChange={this.onEndChange}
                        open={endOpen}
                        onOpenChange={this.handleEndOpenChange}
                        />
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={24} md={24} lg={24} xl={24}>
                        <FormItem
                        // {...formItemLayout}
                        style={{float:'left'}}
                        >
                        <Button type="default" onClick={this.exportClick}>导出至Excel</Button>
                        </FormItem>
                        <FormItem 
                        // {...tailFormItemLayout}
                        style={{float:'right',right:'15%'}}
                        >
                            <Button style={{position: 'absolute',top: '0px',left:'-80px' }}type="primary" htmlType="submit" size="large" >查询</Button>
                            <Button style={{position: 'absolute',top: '0px',right:'-80px' }}type="primary"  onClick={this.handleReset} size="large" >重置</Button> 
                        </FormItem>
                    </Col>
                </Form> 
                <Col sm={24} md={24} lg={24} xl={24}>

                <Table columns={columns} dataSource={data} onExpandedRowsChange={this.onExpandedRowsChange} onChange={this.handleChange} expandedRowRender={this.expandedRowRender}
                    pagination={{
                        showSizeChanger: true,  //是否显示可以设置几条一页的选项
                        showQuickJumper:true,
                        onShowSizeChange(current, pageSize) {  //当几条一页的值改变后调用函数，current：改变显示条数时当前数据所在页；pageSize:改变后的一页显示条数
                            console.log(current, pageSize);
                        },
                        onChange(pageNumber) {
                            console.log('Page: ', pageNumber);
                        }
                    }}
                />
                </Col>
                
            </div>
        );
    }
    }

const WorkManageList = Form.create()(WorkManageLists);
export default WorkManageList;
