import * as React from "react";
import * as ReactDOM from "react-dom";
import  ol from 'openlayers';
import { Link } from 'react-router';

var pointLayer = new ol.layer.Vector({
    source: new ol.source.Vector()
});
var circleLayer = new ol.layer.Vector({
    source: new ol.source.Vector()
});

var circle = new ol.Feature({
    geometry: new ol.geom.Point([0, 0])
});
circle.setStyle(new ol.style.Style({
    image: new ol.style.Circle({
        radius: 10,
        stroke: new ol.style.Stroke({
            color: 'blue',
            size: 100
        })
    })
}));
circleLayer.getSource().addFeature(circle); 
 // 添加一个五星
var star = new ol.Feature({
geometry: new ol.geom.Point([121.522448, 31.0584447])
});
star.setStyle(new ol.style.Style({
image: new ol.style.RegularShape({
  points: 5,    // 顶点个数
  radius1: 20, // 外圈大小
  radius2: 10, // 内圈大小
  stroke: new ol.style.Stroke({ // 设置边的样式
      color: 'red',
      size: 20
  }),
  fill: new ol.style.Fill({ // 设置五星填充样式
      color: 'blue'
  })
})
}));

circleLayer.getSource().addFeature(star);

var gsat = new ol.layer.Tile({
    source: new ol.source.XYZ("Google Satellite",{  
        url: 'http://www.google.cn/maps/vt/pb=!1m4!1m3!1i{z}!2i{x}!3i{y}!2m3!1e0!2sm!3i380072576!3m8!2szh-CN!3scn!5e1105!12m4!1e68!2m2!1sset!2sRoadmap!4e0!5m1!1e0' ,
        type: 'G_SATELLITE_MAP',
         numZoomLevels: 22 
    })  
}

);
var googleMapLayer = new ol.layer.Tile({  
    source: new ol.source.XYZ({  
        url: 'http://khm{0-3}.googleapis.com/kh?v=742&hl=pl&&x={x}&y={y}&z={z}',
        imagerySet: "Google Satellite"
    })  
}); 
var googleMapLayer2 = new ol.layer.Tile({  
    // source:initMap()
}); 
class WorkMap extends React.Component {
    componentDidMount(){
        var map = new ol.Map({  
        layers: [
            googleMapLayer
            ,
            circleLayer
        ],  
        view: new ol.View({  
            center: [121.522448, 31.0584447],  
            projection: 'EPSG:4326',  
            zoom: 10  
        }),  
        target: this.props.Skey  
        });  

    }
      render(){
        var Skey = this.props.Skey
        console.log(Skey,'Skey')
        return (
            <div style={{height:'500px'}}> 
                <div id={Skey} style={{height:'500px'}}></div>
            </div>
            
        );
      }
    }
export default WorkMap;