import React from 'react';
import { Form,Row, Col, Table, Input, Button,Popconfirm,DatePicker ,Select ,Cascader,InputNumber ,Icon  } from 'antd';
import { workData } from '../../axios';
import { Link,hashHistory } from 'react-router';
import {exportExcel} from '../../simpleXlsx';
import moment from 'moment';
import city from '../../utils/city'
const Search = Input.Search
const Option = Select.Option;
const FormItem = Form.Item;
const { MonthPicker, RangePicker } = DatePicker;
const dateFormat = 'YYYY/MM/DD';
const ColProps = {
    xs: 24,
    sm: 12,
    style: {
        marginBottom: 16,
    },
}
let jobTypes = []
let EditableCellQualification = ({ editable, value, onChange,target}) => (
    <div>
      {editable
        ? <div>
            {value[1]?<div>
                    <span>{value[0][0]}:</span>
                        <Input style={{  width:'30%' }}
                            defaultValue={value[0]?value[0][1]:null}
                            min={0}
                            max={100}
                            onChange={(e) => onChange(e.target.value,value[0][0])}/>
                            <div>
                                <span>{value[1][0]}:</span>
                                <Input style={{ width:'30%' }}
                                    defaultValue={value[1]?value[1][1]:null}
                                    min={0}
                                    max={100}
                                    onChange={(e) => onChange(e.target.value,value[1][0])}/>
                                </div>
                        </div>
                    :value.length===0?<div>
                    <span>平均深度:</span>
                        <Input style={{  width:'30%' }}
                            // defaultValue={value[0]?value[0][1]:null}
                            min={0}
                            max={100}
                            onChange={(e) => onChange(e.target.value,'平均深度')}/>
                            <div>
                                <span>达标率:</span>
                                <Input style={{ width:'30%' }}
                                    // defaultValue={value[1]?value[1][1]:null}
                                    min={0}
                                    max={100}
                                    onChange={(e) => onChange(e.target.value,'达标率')}/>
                                </div>
                        </div>
                    :<div>
                    <span>{value[0][0]}:</span>
                        <Input style={{  width:'30%' }}
                            defaultValue={value[0]?value[0][1]:null}
                            min={0}
                            max={100}
                            onChange={(e) => onChange(e.target.value,value[0][0])}/>
                            <div>
                                <span>{value[0][0]=='平均深度'?'达标率':'平均深度'}:</span>
                                <Input style={{ width:'30%' }}
                                    defaultValue={value[1]?value[1][1]:null}
                                    min={0}
                                    max={100}
                                    onChange={(e) => onChange(e.target.value,value[0][0]=='平均深度'?'达标率':'平均深度')}/>
                                </div>
                        </div>}

            </div>
                : <div><span>{value[0]}</span><br/><span>{value[1]}</span></div>
            }
        </div>
  );
let EditableCellId = ({ editable, value, onChange }) => (
    <div>
      {editable
        ? <Input style={{ margin: '-5px 0',width:'80%' }} value={value} onChange={e => onChange(e.target.value)} />
        : value
      }
    </div>
  );
  let EditableCellArea = ({ editable, value, onChange }) => (
    <div>
      {editable?<Cascader style={{width:'70%' }} options={city} onChange={(e,value) => onChange(value)} placeholder="请选择省市区" changeOnSelect  defaultValue={value} showSearch/>
        : value
        }
    </div>
  );
  let EditableCellTimeHorizon = ({ editable, value, onChange}) => (
    <div>
      {editable
        ? <RangePicker defaultValue={value?[moment(value[0], dateFormat), moment(value[1], dateFormat)]:null} format={dateFormat} style={{ margin: '-5px 0',width:'80%' }}onChange={(date,dateString) => onChange(dateString)} />
        : value
      }
    </div>
  );

  let EditableCellJobType = ({ editable, value, onChange }) => (
    <div>
      {editable
        ?   <Select defaultValue={value} style={{ margin: '-5px 0',width:'100%' }} onChange={(value) => onChange(value)}>
        <Option value="深松">深松</Option>
        <Option value="深翻">深翻</Option>
        <Option value="旋耕">旋耕</Option>
        <Option value="免耕播种" >免耕播种</Option>
        <Option value="桔梗还田">桔梗还田</Option>
      </Select>
        : value
      }
    </div>
  );
  //轮作周期
  let EditableCellPeriod = ({ editable, value, onChange }) => (
    <div>
      {editable
        ?   <Select defaultValue={value} style={{ margin: '-5px 0',width:'100%' }} onChange={(value) => onChange(value)}>
        <Option value="1年">1年</Option>
        <Option value="2年">2年</Option>
      </Select>
        : value
      }
    </div>
  );
  let EditableCellTargetArea = ({ editable, value, onChange }) => (
    <div>
    {editable
      ?  <div> <span>合格面积=</span><Select defaultValue={value?value[1]:null} style={{ margin: '-5px 0',width:'60%' }} onChange={(value) => onChange(value)}>
      <Option value="实际作业地块">实际作业地块</Option>
      <Option value="设计作业地块*达标比">设计作业地块*达标比</Option>
    </Select></div>
      : value
    }
  </div>
  );
  //合格面积=0，合格面积=设计作业地块*达标比两种
  let EditableCellBelowArea = ({ editable, value, onChange }) => (
    <div>
    {editable
      ?   <div>
          <span>合格面积=</span><Select defaultValue={value?value[1]:null} style={{ margin: '-5px 0',width:'60%' }} onChange={(value) => onChange(value)}>
      <Option value="0">0</Option>
      <Option value="设计作业地块*达标比">设计作业地块*达标比</Option>
    </Select>
      </div>
      : value
    }
  </div>
  );
const formItemLayout = {
    labelCol: {
        xs: { span:6 },
        sm: { span: 4 },
        lg: {span:4},
        xl: {span:4}
        
    },
    wrapperCol: {
        xs: { span: 12 },
        sm: { span: 6 },
        lg: {span:8},
        xl: {span:8}
    },
};
const tailFormItemLayout = {
    wrapperCol: {
        xs: {
            span: 12,
            offset: 5,
        },
        sm: {
            span: 14,
            offset: 14,
        },
    },
};

class WorkManageLists extends React.Component {
    constructor (props) {
        super(props)
        this.state = {
            count:1,
            answer:{}
            // copyreader
        }
    }
    state = {
        filterDropdownVisible: false,
        data:[],
        searchText: '',
        filtered: false,
        
    };
    onChange1=(e)=>{
    }
    componentDidMount(){
        if(window.localStorage['workCentre']){
            //本地缓存
            let newdata=JSON.parse(window.localStorage['workCentre']) 
            let jobType = []
            for(var i = 0; i<newdata.length; i++){
                if (jobType.indexOf(newdata[i].jobType) == -1){
                    jobType.push(newdata[i].jobType); 
                } 
            }
            for(var i = 0; i < jobType.length; i++){
                // jobTypes.push(<Option key={jobType[i]}>{jobType[i]}</Option>);
            }    
            this.setState({
                data:newdata,    
            }) 
        }else{
            // 后台数据
            workData().then(npm => {
                let newdata = npm.data
                let jobType = []
                for(var i = 0; i<newdata.length; i++){
                    if (jobType.indexOf(newdata[i].jobType) == -1){
                        jobType.push(newdata[i].jobType); 
                    } 
                }
                for(var i = 0; i < jobType.length; i++){
                    // jobTypes.push(<Option key={jobType[i]}>{jobType[i]}</Option>);
                } 
                this.setState({  
                    data:newdata,
                })      
                localStorage.setItem('workCentre',JSON.stringify(newdata))
                
            })   
        }
    }

    //form表单
    handleSubmit = (e) => {
        const { router } = this.props;
        e.preventDefault();
        this.props.form.validateFields((err, values) => {
            if (!err) {
                console.log('Received values of form: ', values);
               
            }
        });
    };

     //获取搜索框输入的内容
    onInputChange = (e) => {
        this.setState({ searchText: e.target.value });
    }

    //搜索框
    onSearch = () => { 
        let newdata=JSON.parse(window.localStorage['workCentre']) 
        const { searchText,data } = this.state;
        // 声明一个全局匹配 忽略大小写的正则
        // 正则内容要看searchText是什么 
        // g表示global全局搜索
        // i表示ignore case 忽略大小写
        const reg = new RegExp(searchText, 'gi');  
        this.setState({
            filterDropdownVisible: false,
            filtered: !!searchText,
            data:newdata.map((record) => {
                const equipment = record.equipment.match(reg)  //筛选设备ID
                const Car = record.bindingCar.match(reg) //筛选绑定车辆
                const Machine = record.bindingMachine.match(reg)  //筛选绑定机具
                const jobType = record.jobType.match(reg)   //筛选作业类型
                const jobSite = record.jobSite.match(reg)   //筛选作业地块
                const workingArea = record.workingArea.match(reg)   //筛选作业面积
                const qualifiedArea = record.qualifiedArea.match(reg)   //筛选合格面积
                const jobState = record.jobState.match(reg)   //筛选作业状态
                const match = equipment||Car||Machine||jobType||jobSite||workingArea||qualifiedArea||jobState
                if (!match) {
                    return null;
                }
                return {
                    ...record,     
                };
            }).filter(record => !!record),
        });
    }

    //约束开始时间
    disabledStartDate = (startValue) => {
        const endValue = this.state.endValue;
        if (!startValue || !endValue) {
        return false;
        }
        return startValue.valueOf() > endValue.valueOf();
    }

    //约束结束时间
    disabledEndDate = (endValue) => {
        const startValue = this.state.startValue;
        if (!endValue || !startValue) {
        return false;
        }
        return endValue.valueOf() <= startValue.valueOf();
    }



//添加标准
    handleAdd = () => {
        const { count, data } = this.state;
        const newData = {
          key: count,
          name: `Edward King ${count}`,
          age: 32,
          address: `London, Park Lane no. ${count}`,
        };
        this.setState({
            data: [newData,...data],
          count: count + 1,
        });
      }
      //编辑
      edit=(key)=> {
        const newData = [...this.state.data];
        const target = newData.filter(item => key === item.key)[0];
        if (target) {
          target.editable = true;
          this.setState({ data: newData });
        }
      }
      //删除
      deleteClick=()=>{

      }
      //改变事件
      handleChange(value, key, column,dd) {
          console.log(value, key, column,9987)
          if(column=='qualification'){
            //     first:['first','result1'],
//     second:['second','result2']
console.log(dd,value)
          }
        const newData = [...this.state.data];
        const target = newData.filter(item => key === item.key)[0];
        if (target) {
            if(column==='area'){
                let area=''
                for (let i=0;i<value.length;i++){
                    area=area+value[i].name+' '
                }
                target.area = area
            }else{
                if(column==='targetArea'){
                    target.targetArea='合格面积='+value
                }else{
                    if(column==='belowArea'){
                        target.belowArea='合格面积='+value
                    }else{ 
                        if(column==='qualification'){
                        console.log(dd,value,target.qualification,7777)
                        let fication=target.qualification
                        console.log(fication,'fication')
                        if(!fication){
                            fication={}
                        }
                        fication[dd]=value
                        console.log(fication,999)
                        target.qualification=fication
                            }else{
                            target[column] = value;
                        }
                    }
                    
                }
               
            }
          
          this.setState({ data: newData });
        }
      }

      beforeChange(value, key, column,target) {
        console.log(value, key, column,target,'933333')
        this.setState({
            [target]:value
        })
        this.handleChange(value,key, column,target)
      }

      //保存
      save=(key)=> {
        const newData = [...this.state.data];
        const target = newData.filter(item => key === item.key)[0];
        if (target) {
          delete target.editable;
          this.setState({ data: newData });
          this.cacheData = newData.map(item => ({ ...item }));
        }
      }
      renderColumns=(text, record, column,target)=> {
        if(column=='id'){
            return (
                <EditableCellId
                  editable={record.editable}
                  value={text}
                  onChange={value => this.handleChange(value, record.key, column)}
                />
              ); 
        }
        if(column=='area'){
            if(Object.prototype.toString.call(text) ==="[object String]") {
                let area= new Array() 
                area=text.split(" ") 
                text=area
            }
        
        return ( <EditableCellArea
              editable={record.editable}
              value={text}
              onChange={value => this.handleChange(value, record.key, column)}
            />
          );}
          if(column=='timeHorizon'){
            if(Object.prototype.toString.call(text) ==="[object String]") {
              let timeHorizon=new Array()
              timeHorizon=text.split("/") 
              text=timeHorizon
            }
            return ( <EditableCellTimeHorizon
                editable={record.editable}
                value={text}
                onChange={value => this.handleChange(value, record.key, column)}
              />
            )
        }
        if(column=='qualification'){
            
            let qualification= new Array() 
            for(let i in text){
                let value=new Array() 
                value[0]=i
                value[1]=text[i]
                qualification.push(value)
            }
            text=qualification
            console.log(text,789)
            // if(text.length===0){

            // }
            // if(Object.prototype.toString.call(text) ==="[object object]") {
            //   let timeHorizon=new Array()
            //   timeHorizon=text.split("/") 
            //   text=timeHorizon
            // }
            return ( <EditableCellQualification
                editable={record.editable}
                value={text}
                onChange={(value,answer) => this.beforeChange(value, record.key, column,answer)}
              />
            )
        }
        if(column=='jobType'){  
            return ( <EditableCellJobType
                editable={record.editable}
                value={text}
                onChange={value => this.handleChange(value, record.key, column)}
              />
            )
        }
        if(column=='period'){  
            return ( <EditableCellPeriod
                editable={record.editable}
                value={text}
                onChange={value => this.handleChange(value, record.key, column)}
              />
            )
        }
        if(column=='targetArea'){
            if(text){
                let timeHorizon=new Array()
                timeHorizon=text.split("=") 
                text=timeHorizon
            }
            return ( <EditableCellTargetArea
                editable={record.editable}
                value={text}
                onChange={value => this.handleChange(value, record.key, column)}
              />
            )
        }
        if(column=='belowArea'){
            if(text){
                let timeHorizon=new Array()
                timeHorizon=text.split("=") 
                text=timeHorizon
            }
          return (<EditableCellBelowArea
                    editable={record.editable}
                    value={text}
                    onChange={value => this.handleChange(value, record.key, column)}
          />
        )}
      }
      

       //取消重置
    handleReset = () => {
        this.props.form.resetFields();
    }
    //删除
    onDelete = (key) => {
        // let vehicle=JSON.parse(window.localStorage['machineTool']) 
        const dataSource = [...this.state.data];
        //更新列表数据
        this.setState({ data: dataSource.filter(item => item.key !== key) });
        //更新本地缓存
        // localStorage.setItem('machineTool',JSON.stringify(vehicle.filter(item => item.key !== key)))
    }
    cancel(key) {
        const newData = [...this.state.data];
        const target = newData.filter(item => key === item.key)[0];
        if (target) {
          Object.assign(target, this.cacheData.filter(item => key === item.key)[0]);
          delete target.editable;
          this.setState({ data: newData });
        }
      }
    render() {
        const { getFieldDecorator } = this.props.form;
        const formItemLayout = {
            labelCol: {
                xs: { span:12 },
                sm: { span: 6 },
            },
            wrapperCol: {
                xs: { span: 12 },
                sm: { span: 12 },
            },
        };
        const tailFormItemLayout = {
            wrapperCol: {
                xs: {
                    span: 12,
                    offset: 0,
                },
                sm: {
                    span: 14,
                    offset: 8,
                },
            },
        };
        const { startValue, endValue, endOpen } = this.state;
        let data=this.state.data      

        const columns = [{
            key: 'id',  
            title: '作业标准ID',
            dataIndex: 'id',
            render: (text, record) => this.renderColumns(text, record, 'id'),
        }, {
            key: 'area',
            title: '所在区域',
            dataIndex: 'area',
            render: (text, record) => this.renderColumns(text, record, 'area')
        },{
            key: 'timeHorizon',
            title: '时间范围',
            dataIndex: 'timeHorizon',
            render: (text, record) => this.renderColumns(text, record, 'timeHorizon')
        },
        {
            key: 'qualification',
            title: '合格条件',
            dataIndex: 'qualification',
            render: (text, record) => this.renderColumns(text, record, 'qualification')
        },
        {
            key: 'jobType',
            title: '作业类型',
            dataIndex: 'jobType',
            // filters:jobList,
             onFilter: (value, record) =>{
                return record.jobType.indexOf(value) === 0
            } ,
            render: (text, record) => this.renderColumns(text, record, 'jobType')
        },{
            key: 'period',
            title: '轮作周期',
            dataIndex: 'period',
            render: (text, record) => this.renderColumns(text, record, 'period')
        }, {
            key: 'targetArea',
            title: '达标地块标准',
            dataIndex: 'targetArea',
            render: (text, record) => this.renderColumns(text, record, 'targetArea')
        },{
            key: 'belowArea',
            title: '不达标地块的标准',
            dataIndex: 'belowArea',
            render: (text, record) => this.renderColumns(text, record, 'belowArea')
        },{
            key: 'operation',
            title: '操作',
            dataIndex: 'operation',
            render: (text, record) => {  
                const { editable } = record;   
                return ( 
            <div className="editable-row-operations">
            {
              editable ?
                <span>
                  <a onClick={() => this.save(record.key)}>保存</a>
                </span>
                : <span>
                    <a onClick={() => this.edit(record.key)}>编辑</a>
                    <Popconfirm title="确定要删除吗?" onConfirm={() => this.onDelete(record.key)}>
                    <a>删除</a>
                  </Popconfirm>
                    </span>
            }
                </div>)}
        }];
        return (
            <div>
                {/* setFieldsValue */}
                <Form onSubmit={this.handleSubmit}>
                    
                    <Col sm={8} md={8} lg={8} xl={8}

                    >
                        <FormItem
                        {...formItemLayout}
                        label="作业日期"
                        >
                        {getFieldDecorator('jobdate', {
                        })(
                        <DatePicker style={{ width:"100%"}} initialValue={moment('2015/01/01', dateFormat)} format={dateFormat} placeholder="请选择设备生产日期"/>            
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={8} md={8} lg={8} xl={8}>
                        <FormItem
                        {...formItemLayout}
                        label="开始时间"
                        >
                        {getFieldDecorator('startdate', {
                            setFieldsValue:startValue,
                        })(
                        <DatePicker
                        disabledDate={this.disabledStartDate}
                        showTime
                        format="HH:mm:ss"
                        setFieldsValue={startValue}
                        placeholder="请输入开始时间"
                        onChange={this.onStartChange}
                        onOpenChange={this.handleStartOpenChange}
                        />
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={8} md={8} lg={8} xl={8}>
                        <FormItem
                        {...formItemLayout}
                        label="结束时间"
                        >
                        {getFieldDecorator('enddate', {
                            setFieldsValue:endValue,
                        })(
                        <DatePicker
                        disabledDate={this.disabledEndDate}
                        showTime
                        format="HH:mm:ss"
                        setFieldsValue={endValue}
                        placeholder="请输入结束时间"
                        onChange={this.onEndChange}
                        open={endOpen}
                        onOpenChange={this.handleEndOpenChange}
                        />
                        )}
                        </FormItem>
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6}>
                        <FormItem
                        {...formItemLayout}
                        >
                        <Button type="default" onClick={this.handleAdd}>添加标准</Button>
                        </FormItem>
                
                    </Col>
                    <Col sm={6} md={6} lg={6} xl={6} offset={12}> 
                        <FormItem {...tailFormItemLayout}>
                            <Button type="primary" style={{position: 'absolute',top: '0px',left:'-20px' }} htmlType="submit" size="large" >查询</Button>
                            <Button type="primary"  style={{position: 'absolute',top: '0px',left:'50px'}} size="large" onClick={this.handleReset}>重置</Button> 
                        </FormItem>
                    </Col> 
                </Form> 
                <Col sm={24} md={24} lg={24} xl={24}>
                <Table columns={columns} dataSource={data} onChange={this.handleChange} 
                    pagination={{
                        showSizeChanger: true,  //是否显示可以设置几条一页的选项
                        showQuickJumper:true,
                        onShowSizeChange(current, pageSize) {  //当几条一页的值改变后调用函数，current：改变显示条数时当前数据所在页；pageSize:改变后的一页显示条数
                            console.log(current, pageSize);
                        },
                        onChange(pageNumber) {
                            console.log('Page: ', pageNumber);
                        }
                    }}
                />
                </Col>
                
            </div>
        );
    }
    }

const WorkManageList = Form.create()(WorkManageLists);
export default WorkManageList;
